<?php

function user_option_load($username) {
  global $u_java;
  
  $u_id=0;
  $u_email="";
  $u_id_grp=1;
  $u_enable=0;
  $u_lang="";
  $u_graph_x=0;
  $u_graph_y=0;
  $u_graph_theme="";
  $u_style="";

  $res=SQL_query("SELECT id,email,id_grp,enable,lang,graph_x,graph_y,graph_theme,style,java,timezone,admin FROM x_user WHERE name='".SQL_escape($username)."'");
  if ($res) {
    if (($row=SQL_fetch_array($res))) {
      $u_id=$row[0];
      $u_email=$row[1];
      $u_id_grp=$row[2];
      $u_enable=$row[3];
      $u_lang=$row[4];
      $u_graph_x=$row[5];
      $u_graph_y=$row[6];
      $u_graph_theme=$row[7];
      $u_style=$row[8];
      if ($row[9]) {
        $u_java=($row[9]=="1")?"1":"0";	
      }
      $u_timezone=$row[10];
      $u_admin=$row[11];
    }
    SQL_free_result($res);
  }
  else
    MsgFatal(x("Error when getting user options."));
  text_setlanguage($u_lang);
      
  if (!$u_enable) {
    MsgInfo(x("Your account is disabled, please, contact administrator."));
    echo "</BODY></HTML>";
    die();
  }

  $u_rights="";
  $res=SQL_query("SELECT rights FROM x_group WHERE id=$u_id_grp");
  if ($res) {
    while (($row=SQL_fetch_array($res)))
      $u_rights=$row[0];
    SQL_free_result($res);
  }

  if ($u_admin && !strstr($u_rights,"admin"))
    $u_rights="admin";
  
  prgsession_register('u_id',$u_id);
  prgsession_register('u_email',$u_email);
  prgsession_register('u_id_grp',$u_id_grp);
  prgsession_register('u_rights',$u_rights);  
  prgsession_register('u_lang',$u_lang);  
  prgsession_register('u_graph_x',$u_graph_x);  
  prgsession_register('u_graph_y',$u_graph_y);  
  prgsession_register('u_graph_theme',$u_graph_theme);  
  prgsession_register('u_style',$u_style);  
  prgsession_register('u_java',$u_java);  
  prgsession_register('u_timezone',$u_timezone);  
  prgsession_register('logged',1);
}


function global_option_load($username) {
  getGlobalVar('REMOTE_ADDR',$lf,PRG_SERVER);

  $g_email="";
  $g_email_login="";
  $g_style="";
  $g_mstyle="";
  $g_msstyle="";
  $g_community="";
  $g_dns="";
  $g_dnspos="360";
  $g_dnsneg="30";

  $res=SQL_query("SELECT name,value FROM x_global");
  if ($res) {
    while (($row=SQL_fetch_array($res))) {
      if ($row[0]=="email")
	$g_email=$row[1];
      if ($row[0]=="email_login")
	$g_email_login=$row[1];
      if ($row[0]=="email_bug")
        $g_email_bug=$row[1];
      if ($row[0]=="style")
        $g_style=$row[1];
      if ($row[0]=="mstyle")
        $g_mstyle=$row[1];
      if ($row[0]=="msstyle")
        $g_msstyle=$row[1];
      if ($row[0]=="community")
        $g_community=$row[1];
      if ($row[0]=="dns_allow")
        $g_dns=$row[1];
      if ($row[0]=="dns_pos")
        $g_dnspos=$row[1];
      if ($row[0]=="dns_neg")
        $g_dnsneg=$row[1];
    }
    SQL_free_result($res);
  }
  else
    MsgFatal(x("Error when getting global options."));
  
  $text="User '$username' login on ".strftime("%x %X",time())." from $lf (".gethostbyaddr_cache($lf).")";

  if ($g_email_login && $g_email)
    @mail($g_email,PRG_NAME." (login info)",$text);
    
  prgsession_register('g_email',$g_email);
  prgsession_register('g_email_login',$g_email_login);
  prgsession_register('g_email_bug',$g_email_bug);
  prgsession_register('g_style',$g_style);
  prgsession_register('g_mstyle',$g_mstyle);
  prgsession_register('g_msstyle',$g_msstyle);
  prgsession_register('g_community',$g_community);
  prgsession_register('g_dns',$g_dns);
  prgsession_register('g_dnspos',$g_dnspos);
  prgsession_register('g_dnsneg',$g_dnsneg);
}


function user_lastlog($username) {
  getGlobalVar('REMOTE_ADDR',$lf,PRG_SERVER);
  $lt=time();
  $v=SQL_escape(array($username,$lt,$lf));
  SQL_query("INSERT INTO x_lastlog (username,lasttime,lastfrom) VALUES('$v[0]','$v[1]','$v[2]')");
  SQL_query("DELETE FROM x_lastlog WHERE lasttime<".time()-7776000); /* delete older than 3mon*/
}



function script_auth($cmd,$user,$pass) {
  $cmd=escapeshellcmd(str_replace("%u",$user,$cmd));
  $descriptorspec = array(
    0 => array("pipe", "r")  // stdin is a pipe that the child will read from
  );
  $process = proc_open($cmd, $descriptorspec, $pipes);
  if (is_resource($process)) {
    fputs($pipes[0],$pass);
    fflush($pipes[0]);
    fclose($pipes[0]);

    // It is important that you close any pipes before calling
    // proc_close in order to avoid a deadlock
    return proc_close($process);
  }
  return -1;
}


function MyErrorHandler($errno,$errmsg,$filename,$linenum,$vars) {
  global $g_email,$g_show_warning,$g_email_bug;
  
  $dt = date("Y-m-d H:i:s (T)");
  $errortype=array (
      E_ERROR          => "Error",
      E_WARNING        => "Warning",
      E_PARSE          => "Parsing Error",
      E_NOTICE          => "Notice",
      E_CORE_ERROR      => "Core Error",
      E_CORE_WARNING    => "Core Warning",
      E_COMPILE_ERROR  => "Compile Error",
      E_COMPILE_WARNING => "Compile Warning",
      E_USER_ERROR      => "User Error",
      E_USER_WARNING    => "User Warning",
      E_USER_NOTICE    => "User Notice",
      E_STRICT          => "Runtime Notice"
  );
 
  $user_errors=array(E_USER_ERROR,E_USER_WARNING,E_USER_NOTICE);
   
  $err .= "datetime: $dt\n";
  $err .= "errornum: $errno\n";
  $err .= "errortype: ".$errortype[$errno]."\n";
  $err .= "errormsg: $errmsg\n";
  $err .= "scriptname: $filename\n";
  $err .= "line: $linenum\n";
  if (in_array($errno, $user_errors))
     $err .= "vartrace: " . wddx_serialize_value($vars, "Variables")."\n";

   
  if (defined('PRG_ERRLEVEL') && ($errno & PRG_ERRLEVEL)) {
    echo $errortype[$errno].": ".$errmsg." file: ".$filename." line: ".$linenum."\n";

    if ($errno!=E_NOTICE && $errno!=E_USER_NOTICE) {
      if ($g_email && $g_email_bug)
        mail($g_email,PRG_NAME." (bug report)",$err);
    }
  }
  if ($errno==E_ERROR || $errno==E_PARSE || $errno==E_CORE_ERROR || $errno==E_COMPILE_ERROR)
    die();
}

getGlobalVar('logged',$logged,PRG_SESSION);
if ($logged) {
  getGlobalVar('u_id',$u_id,PRG_SESSION);
  getGlobalVar('u_name',$u_name,PRG_SESSION);
  getGlobalVar('u_email',$u_email,PRG_SESSION);
  getGlobalVar('u_id_grp',$u_id_grp,PRG_SESSION);
  getGlobalVar('u_rights',$u_rights,PRG_SESSION);
  getGlobalVar('u_lang',$u_lang,PRG_SESSION);  
  getGlobalVar('u_graph_x',$u_graph_x,PRG_SESSION);  
  getGlobalVar('u_graph_y',$u_graph_y,PRG_SESSION);  
  getGlobalVar('u_graph_theme',$u_graph_theme,PRG_SESSION);  
  getGlobalVar('u_style',$u_style,PRG_SESSION);  
  getGlobalVar('u_java',$u_java,PRG_SESSION);  
  
  getGlobalVar('g_email',$g_email,PRG_SESSION);
  getGlobalVar('g_email_login',$g_email_login,PRG_SESSION);
  getGlobalVar('g_email_corp',$g_email_corp,PRG_SESSION);
  getGlobalVar('g_show_warning',$g_show_warning,PRG_SESSION);  
  getGlobalVar('g_style',$g_style,PRG_SESSION);  
  getGlobalVar('g_mstyle',$g_mstyle,PRG_SESSION);  
  getGlobalVar('g_msstyle',$g_msstyle,PRG_SESSION);  
  getGlobalVar('g_community',$g_community,PRG_SESSION);  

  getGlobalVar('g_dns',$g_dns,PRG_SESSION);  
  getGlobalVar('g_dnspos',$g_dnspos,PRG_SESSION);  
  getGlobalVar('g_dnsneg',$g_dnsneg,PRG_SESSION);  

  text_setlanguage($u_lang);

  getGlobalVar('u_timezone',$u_timezone,PRG_SESSION);
  if (isset($u_timezone) && $u_timezone && function_exists('date_default_timezone_set')) {
    @date_default_timezone_set($u_timezone);
  }

#  error_reporting(0);
#  set_error_handler("MyErrorHandler");
}




if (!function_exists("mysql_connect") && !function_exists("mysqli_connect") && function_exists("dl")) {
  @dl("mysql.so");
  @dl("mysqli.so");
}

if (!function_exists("mysql_connect") && !function_exists("mysqli_connect")) {
  echo "<center>\n";
  MsgFatal(
"MySQL database extension is not supported by PHP.<br/><br/>\n ".
"Solution: Please, install php-mysql package and/or enable mysql extension in your ".
"PHP configuration file. For package installation in the Debian distribution ".
"use the following command: ".

"<pre>apt-get install php4-mysql</pre> ".

"For installation in the RedHat, SuSE and other rpm based distributions use ".
"the following command: ".

"<pre>up2date php-mysql</pre> ".

"or download php-mysql.rpm package from the distribution home page and use the ".
"<i>rpm</i> utility: ".

"<pre>rpm -i php-mysql.rpm</pre> ".

"Try to find the <i>mysql.so</i> file by using the following command: ".

"<pre>find /usr -name mysql.so</pre> ".

"When you find this file, activate the extension in your <i>php.ini</i> file (this ".
"file is usually located in the directory <i>/etc/php4/apache/</i> or <i>/etc</i>) by typing option: ".

"<pre>extension=mysql.so</pre> ".

"You can use Midnight command (mc) program to edit this file. If you don't find ".
"the <i>mysql.so</i> file, try to install a new package php4-mysql (package name php4-mysql is used ".
"by Debian, in Fedora/SuSE/RHEL distributions it will be found with the same or ".
"similar to the Debian's name, i.e. php-mysql.rpm).<br/><br/>".

"Restart apache web server after changes."
  );
}




if ((!function_exists("imagegd2") || !function_exists("imagecreatetruecolor")) && function_exists("dl"))
  @dl("gd.so");

if (!function_exists("imagegd2") || !function_exists("imagecreatetruecolor")) {
  echo "<center>\n";
  MsgFatal(
"Graphical extension (GD) version 2 is not supported by PHP.<br/><br/>\n ".
"Solution: Please, install php-gd package and/or enable GD extension in your ".
"PHP configuration file. For package installation in the Debian distribution ".
"use the following command: ".

"<pre>apt-get install php4-gd</pre> ".

"For installation in the RedHat, SuSE and other rpm based distributions use ".
"the following command: ".

"<pre>up2date php-gd</pre> ".

"or download php-gd.rpm package from the distribution home page and use the ".
"<i>rpm</i> utility: ".

"<pre>rpm -i php-gd.rpm</pre> ".

"Try to find the <i>gd.so</i> file by using the following command: ".

"<pre>find /usr -name gd.so</pre> ".

"When you find this file, activate the extension in your <i>php.ini</i> file (this ".
"file is usually located in the directory <i>/etc/php4/apache/</i> or <i>/etc</i>) by typing option: ".

"<pre>extension=gd.so</pre> ".

"You can use Midnight command (mc) program to edit this file. If you don't find ".
"the <i>gd.so</i> file, try to install a new package php4-gd (package name php4-gd is used ".
"by Debian, in Fedora/SuSE/RHEL distributions it will be found with the same or ".
"similar to the Debian's name, i.e. php-gd.rpm).<br/><br/>".


"Restart apache web server after changes."
  );
}


// in PHP 5.3 is dl disabled !
if (!function_exists("snmpget") && function_exists("dl"))
  @dl("snmp.so");


$save_path=ini_get('session.save_path');
if ($save_path) {
  $dfs=disk_free_space($save_path);
  if ($dfs!==false && $dfs>=0 && $dfs<=5000000) {
    echo "<center>\n";
    MsgFatal(
"I cannot create a data session - disk is full or low free disk space!<br/><br/>\n".
"Solution: Please, remove some tables or unused files. For removing data tables use the following steps.\n".
"<ol>\n".
"<li>Shutdown MySQL database. Run the following command:<br/>".
"<pre>/etc/init.d/mysql stop</pre></li>\n".
"<li>To sort by size the list of database tables, run the following command:".
"<pre>ls -laS /var/lib/mysql/nfx | more</pre></li>\n".
"<li>Select the biggest files and delete them. You can use the rm utility.</br>".
"i.e. <pre>rm /var/lib/mysql/nfx/h1_06063008.*</pre>".
"Hourly tables start with letter 'h', daily with 'd', weekly with 'w' and monthly with 'm'.</li>\n".
"<li>To start MySQL database, run the following command:".
"<pre>/etc/init.d/mysql start</pre></li>\n".
"<li>Log in to the web interface and lower the number of stored tables".
"for your collectors (menu Options->Collector).</li>\n</ol>\n"
	    );

  }
  $s_p=fileperms($save_path); /* check for sticky bit permissions */
  $s_r=is_readable($save_path);
  $s_w=is_writeable($save_path);
  if (($s_r!==false) && ($s_w!==false) && ($s_p!==false)) {
    if ((!$s_r && (!($s_p&0x0200)))||(!$s_w)) {
      echo "<center>\n";
      MsgFatal(
"I cannot create a data session - there are missing permissions to the directory $save_path!<br/><br/>\n".
"Solution: Please, set up read, write and execute permissions for $save_path directory.\n".
"Run the following command: <br/>".
"<pre>chmod a+rwx $save_path</pre>\n".
"or<br/>\n".
"<pre>chmod o+wt $save_path</pre>\n"
      );
    }
  }
}


?>