<?php
define('HELPMARK','user_anomalies.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once('modules.php');


getGlobalVar('command',$command);
getGlobalVar('btn_save',$btn_save);

getGlobalVar('cid',$cid);
getGlobalVar('na',$na);
getGlobalVar('nas',$nas);
getGlobalVar('srct',$srct);
getGlobalVar('src',$src);
getGlobalVar('dstt',$dstt);
getGlobalVar('dst',$dst);

getGlobalVar('exc_et',$exc_et);
getGlobalVar('exc_cid',$exc_cid);
getGlobalVar('exc_na',$exc_na);
getGlobalVar('exc_src',$exc_src);
getGlobalVar('exc_dst',$exc_dst);

if (!isset($srct)) $srct=0;
if (!isset($dstt)) $dstt=0;

PageHead();
PageLogo();
MenuStart();
PageTitle(x("Network anomalies - Exclude anomaly"),'i_anomaly.gif');

check_command('exclude');
demo_cmd('exclude');

$list_coll=list_table("x_coll","ORDER BY name");

if (!is_array($list_coll)|| !count($list_coll))
  MsgFatal(x("No available collector. Go to menu Options-&gt;Collectors first."));

if (!is_array($na_mod) || !count($na_mod))
  MsgFatal(x("No available network anomaly module."));



if ($command=="exclude") {
  $error="";
  switch ($exc_et) {
    default:
    case 1: $v_et=time()+86400; break;
    case 2: $v_et=time()+(86400*3); break;
    case 3: $v_et=time()+(86400*7); break;
    case 4: $v_et=time()+(86400*31); break;
    case 5: $v_et=0; break;
  }

  if ($exc_cid=="any")
    $v_cid="*";
  else if (isset($list_coll[$exc_cid]))
    $v_cid=$exc_cid;
  else if (!$error)
    $error=x("Unknown collector.");
    
  $v_na_a=explode(":",$exc_na);
  if ($v_na_a[0]=="any") { $v_na="*"; $v_nas="*"; }
  else if ($v_na_a[1]=="any") { $v_na=$v_na_a[0]; $v_nas="*"; }
  else { $v_na=$v_na_a[0]; $v_nas=$v_na_a[1]; }
  
  $v_src_a=explode(":",$exc_src);
  if ($v_src_a[0]=="any") { $v_srct="*"; $v_src="*"; }
  elseif ($v_src_a[1]=="any") { $v_srct=$v_src_a[0]; $v_src="*"; }
  else { $v_srct=$v_src_a[0]; $v_src=$v_src_a[1]; }

  $v_dst_a=explode(":",$exc_dst);
  if ($v_dst_a[0]=="any") { $v_dstt="*"; $v_dst="*"; }
  elseif ($v_dst_a[1]=="any") { $v_dstt=$v_dst_a[0]; $v_dst="*"; }
  else { $v_dstt=$v_dst_a[0]; $v_dst=$v_dst_a[1]; }


  if ($v_nas=="*" && ($v_srct=="*" || $v_src=="*") && ($v_dstt=="*" || $v_dst=="*"))
    $error=x("Too universal exclude condition. Please use more exact condition or modify anomaly options in the menu Options-&gt;Anomalies.");
  
  if (!$error) {
    $v=SQL_escape(array($v_et,$v_cid,$v_na,$v_nas,$v_srct,$v_src,$v_dstt,$v_dst));
    $q="INSERT INTO x_na_ign (et,cid,na,nas,srct,src,dstt,dst) VALUES ('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]')";
    if (!SQL_query($q))
      $error=x("Error while setting exclusion rule.")."<br/></br>\n".x("Maybe this rule already exist.");
  }

  if (!$error) {
    MsgInfo(x("Exclusion rule inserted successfully ...")."<br/><br/>\n".ShowLink(x("Return to the Anomalies menu."),"anomaly.php"));
  }
  else {
    MsgError($error);
    $command="";
  }
}




if ($command=="") {
    $elist_et[1]=x("24 hours");
    $elist_et[2]=x("3 days");
    $elist_et[3]=x("7 days");
    $elist_et[4]=x("31 days");
    $elist_et[5]=x("Forever");

    if (isset($cid) && $cid)
      $elist_cid[$cid]=$list_coll[$cid];
    $elist_cid['any']=x("*** any collector ***");

    if (isset($na) && $na && isset($nas) && $nas) {
      if (isset($na_mod[$na]['nas'][$nas]) && $na_mod[$na]['nas'][$nas])
        $elist_na["$na:$nas"]=$na_mod[$na]['name']." - ".$na_mod[$na]['nas'][$nas];
      if (isset($na_mod[$na]['name']) && $na_mod[$na]['name'])
        $elist_na["$na:any"]=$na_mod[$na]['name'];
    }
    elseif (isset($na) && $na) {
      if (isset($na_mod[$na]['name']) && $na_mod[$na]['name'])
        $elist_na["$na:any"]=$na_mod[$na]['name'];
    }
    $elist_na['any']=x("*** any anomaly ***");
    
    if (isset($srct)) {
      switch ($srct) {
        case 0:	$elist_src["0:0"]=x("*** only N/A source ***");
		break;
        case 1: $elist_src["1:$src"]=num2ip($src);
		$elist_src["1:any"]=x("*** any source IP address ***");
		break;
      }
    }
    $elist_src['any']=x("*** any source ***");

    if (isset($dstt)) {
      switch ($dstt) {
        case 0:	$elist_dst["0:0"]=x("*** only N/A destination ***");
		break;
        case 1: $elist_dst["1:$dst"]=num2ip($dst);
		$elist_dst["1:any"]=x("*** any destination IP address ***");
		break;
      }
    }
    $elist_dst['any']=x("*** any destination ***");

    FormStart();
    
    echo InputHidden("command","exclude");
    echo InputHidden("cid",$cid);
    echo InputHidden("na",$na);
    echo InputHidden("nas",$nas);
    echo InputHidden("srct",$srct);
    echo InputHidden("src",$src);
    echo InputHidden("dstt",$dstt);
    echo InputHidden("dst",$dst);
    
    WinStart(x("Exclude anomaly"));
    TItem(x("Exclude anomaly for:"));
    TItem(InputSelect("exc_et",select_list($elist_et,$exc_et)));
    TNext();
    
    TItem(x("Collector:"));
    TItem(InputSelect("exc_cid",select_list($elist_cid,$exc_cid)));
    TNext();

    TItem(x("Network anomaly:"));
    TItem(InputSelect("exc_na",select_list($elist_na,$exc_na)));
    TNext();
    
    TItem(x("Source:"));
    TItem(InputSelect("exc_src",select_list($elist_src,$exc_src)));
    TNext();

    TItem(x("Destination:"));
    TItem(InputSelect("exc_dst",select_list($elist_dst,$exc_dst)));
    TNext();

    TItem("<br/><br/>".InputSubmit("btn_save",x("Exclude anomaly")),'align="center" colspan="2"');
    FormEnd();
}

MenuEnd();
PageTail();




/*  F U N C T I O N S  */



function MySubMenu() {
  global $command,$cid;
  if ($command=="module" || $command=="modulesave")
    $mysubmenu[]=array('caption'=>x("Edit collector"),'url'=>"anomaly.php?command=coll&cid=$cid");
  $mysubmenu[]=array('caption'=>x("Global"),'url'=>'anomaly_glb.php');
  $mysubmenu[]=array('caption'=>x("Collectors"),'url'=>'anomaly.php');
  $mysubmenu[]=array('caption'=>x("Exclusions"),'url'=>'anomaly_exl.php');
  MenuSub(x("Anomalies"),$mysubmenu);
}


?>