<?php
define('HELPMARK','config_imagestore.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('name',$name);
getGlobalVar('grp',$grp);
getGlobalVar('type',$type);


PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Image store"),'i_imagestore.gif');
RequireRights("options");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");


if ($command=="addsubmit") {
    $img_w=0; $img_h=0; $datax="";
    if ($_FILES['data']['tmp_name']) {
      $handle = fopen($_FILES['data']['tmp_name'],'rb');
      if ($handle) {
        $file_content = fread($handle,filesize($_FILES['data']['tmp_name']));
        fclose($handle);
      }
      $datax=base64_encode($file_content);
      $img_src = imagecreatefromstring($file_content);
      $img_w = ImageSX($img_src);
      $img_h = ImageSY($img_src);
      imagedestroy($img_src);
    }
    $v=SQL_escape(array($name,$grp,$type));
    if (!req_var($name,x("name")))
      $command="add";
    elseif (!req_var($grp,x("group")))
      $command="add";
    elseif (!$datax) {
      MsgError(x("No image imported."));
      $command="add";
    }
    elseif (!$img_w || !$img_h) {
      MsgError(x("File imported successfully, but GD library doesn't support this image type."));
      $command="add";
    }
    else {
      $err=0;
      $off=0;
      $maxpacket=250000;

      SQL_query("SET max_allowed_packet=16000000");
      while (!$err && ($off<strlen($datax))) {
        $dataxx=substr($datax,$off,$maxpacket);
	if ($off==0)
	  $q="INSERT INTO x_imagestore (name,grp,type,data) VALUES('$v[0]','$v[1]','$v[2]','$dataxx')";
	else
	  $q="UPDATE x_imagestore SET data=CONCAT(data,'$dataxx') WHERE name='$v[0]' AND grp='$v[1]'";
        
	if (!SQL_query($q))
	  $err=1;
        $off+=$maxpacket;
      }
      if (!$err) {
        MsgInfo(x("Image item %s created successfully ..."),$name);
        $command="";
      }
      else {
	SQL_query("DELETE FROM x_imagestore WHERE name='$v[0]' AND grp='$v[1]'");
        MsgError(x("Insert failed. Maybe you tried inserting duplicate name."));
        $command="add";
      }
    }
}

if ($command=="editsubmit") {
    $img_w=0; $img_h=0; $datax="";
    if ($_FILES['data']['tmp_name']) {
      $handle = fopen($_FILES['data']['tmp_name'],'rb');
      if ($handle) {
        $file_content = fread($handle,filesize($_FILES['data']['tmp_name']));
        fclose($handle);
      }
      $datax=base64_encode($file_content);
      $img_src = imagecreatefromstring($file_content);
      $img_w = ImageSX($img_src);
      $img_h = ImageSY($img_src);
      imagedestroy($img_src);
    }
    $v=SQL_escape(array($id,$name,$grp,$type));
    if (!req_var($name,x("name")))
      $command="edit";
    elseif (!req_var($grp,x("group")))
      $command="edit";
    elseif ($_FILES['data']['tmp_name'] && !$datax) {
      MsgError(x("No image imported."));
      $command="edit";
    }
    elseif ($datax && (!$img_w || !$img_h)) {
      MsgError(x("File imported successfully, but GD library doesn't support this image type."));
      $command="edit";
    }
    else {
      $err=0;
      $off=0;
      $maxpacket=250000;
      SQL_query("SET max_allowed_packet=16000000");
      if (!$datax)
	$err=!SQL_query("UPDATE x_imagestore SET name='$v[1]',grp='$v[2]',type='$v[3]' WHERE id='$v[0]'");
      else {
        while (!$err && ($off<strlen($datax))) {
          $dataxx=substr($datax,$off,$maxpacket);
	  if ($off==0)
	    $q="UPDATE x_imagestore SET name='$v[1]',grp='$v[2]',type='$v[3]',data='$dataxx' WHERE id='$v[0]'";
	  else
	    $q="UPDATE x_imagestore SET data=CONCAT(data,'$dataxx') WHERE id='$v[0]'";
	  if (!SQL_query($q))
	    $err=1;
          $off+=$maxpacket;
        }
      }

      if (!$err) {
        MsgInfo(x("Image item %s updated successfully ..."),$name);
        $command="";
      }
      else {
	SQL_query("DELETE FROM x_imagestore WHERE name='$v[0]' AND grp='$v[1]'");
        MsgError(x("Update failed. Maybe you tried inserting duplicate name."));
        $command="edit";
      }
    }
}




if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_imagestore WRITE");

	$res=SQL_query("SELECT name FROM x_imagestore WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_imagestore WHERE id='$v'")) {
	  MsgError(x("Delete failed. Image %s wasn't deleted."),$name);
	  $error=1;
	}
	
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected images were deleted ...")); 
  }
  $command="";
}




if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,grp,type,data FROM x_imagestore WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$grp=$row[1];
	$type=$row[2];
	$datax=$row[3];
        SQL_free_result($res);
      }
    }

    echo "<FORM ENCTYPE=\"multipart/form-data\" ACTION=\"imagestore.php\" METHOD=\"post\">";

    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add image store item"));
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit image store item"));
      TItem(x("ID:"));
      TItem("<B>$id</B>");
      TNext();
    }
        
    TItem(x("Name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("Group:"));
    TItem(Input("grp",$grp,255));
    TNext();
    TItem(x("Type:"));
    TItem(Input("type",$type,255));
    TNext();
    TItem(x("Image file:"));
    TItem(InputFile("data"));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    if (ini_get('upload_max_filesize')||ini_get('post_max_size')||ini_get('memory_limit')) {
      $umf=return_bytes(ini_get('upload_max_filesize'));
      $pms=return_bytes(ini_get('post_max_size'));
      $ml=return_bytes(ini_get('memory_limit'));
      $maxsize=number2human(min($umf,$pms,$ml));
      echo "<BR><I>".x("Note: Maximal image file size is %sB",$maxsize)."</I><BR><BR>\n";
    }
    if ($command=="edit" && $datax) {
      $img_src = imagecreatefromstring(base64_decode($datax));
      $img_w = imagesx($img_src);
      $img_h = imagesy($img_src);
      imagedestroy($img_src);
      WinStart(x("Stored image [%dx%d]",$img_w,$img_h));
      TItem(ShowImage("$name","imagestore_i.php?id=$id"));
      WinEnd;
    }
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected images?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {
  $res=SQL_query("SELECT id,name,grp,type,length(data) FROM x_imagestore ORDER BY grp,name,type");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Group"));
      THItem(x("Name"));
#      THItem(x("Type"));
      THItem(x("Size"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[2]);
	TItem($row[1]);
#	TItem($row[3]);
	TItem(number2human($row[4]),'ALIGN="right"');
	TItem(ShowLink(x("Edit"),"imagestore.php?command=edit&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No image found ... Please, click on the 'Add' link in the left 'Image store' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'imagestore.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'imagestore.php?command=add');
  MenuSub(x("Image store"),$mysubmenu);
}

function return_bytes($val) {
   $val = trim($val);
   $last = strtolower($val{strlen($val)-1});
   switch($last) {
       // The 'G' modifier is available since PHP 5.1.0
       case 'g':
           $val *= 1024;
       case 'm':
           $val *= 1024;
       case 'k':
           $val *= 1024;
   }

   return $val;
}

?>