<?php
define('HELPMARK','#config_port');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('name',$name);
getGlobalVar('protocol',$protocol);
getGlobalVar('port',$port);
getGlobalVar('descr',$descr);

$descr=strip_lfcr($descr);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Port list"),'i_listport.gif');
RequireRights("options");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");


$name=strtolower($name);

if ($command=="addsubmit") {
    $error="";
    $proto=proto2num($protocol);
    $v=SQL_escape(array($name,$proto,$port,$descr));
    var_number($error,'proto',x("protocol"),"",1,255);
    var_number($error,'port',x("port number"),"",1,65535);
    if ($error) {
      $command="add";
    }
    elseif (!req_var($name,x("name")))
      $command="add";
    else
    if (SQL_query("INSERT INTO x_portname (name,protocol,port,descr) 
	VALUES('$v[0]','$v[1]','$v[2]','$v[3]')")) {
      MsgInfo(x("Port assignment %s created successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate item."));
      $command="add";
    }
}


if ($command=="editsubmit") {
    $error="";
    $proto=proto2num($protocol);
    $v=SQL_escape(array($id,$name,$proto,$port,$descr));
    var_number($error,'proto',x("protocol"),"",1,255);
    var_number($error,'port',x("port number"),"",1,65535);
    if ($error) {
      $command="edit";
    }
    elseif (!req_var($name,x("name")))
      $command="edit";
    else
    if (SQL_query("UPDATE x_portname SET name='$v[1]',protocol='$v[2]',port='$v[3]',descr='$v[4]' WHERE id='$v[0]'")) {
      MsgInfo(x("Port assignment %s updated successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate item."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);

	$res=SQL_query("SELECT name FROM x_portname WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_portname WHERE id='$v'")) {
	    MsgError(x("Delete failed. Port assignment %s wasn't deleted."),$name);
	    $error=1;
	}
      }
    }
    if (!$error)
      MsgInfo(x("Selected port assignments were deleted ...")); 
  }
  $command="";
}




if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,protocol,port,descr FROM x_portname WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$protocol=num2proto($row[1]);
	$port=$row[2];
	$descr=$row[3];
        SQL_free_result($res);
      }
    }
    FormStart();
    popup_script("450","500",'','no');
    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new port assignment"));
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit port assignment"));
    }
        
    TItem(x("Port name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("Protocol:"));
    TItem(Input("protocol",$protocol,32).show_listproto("protocol"));
    TNext();    
    TItem(x("Port number:"));
    TItem(Input("port",$port,32));
    TNext();
    TItem(x("Description:"));
    TItem(InputText("descr",$descr));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected port assignments?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {
  $res=SQL_query("SELECT id,name,protocol,port,descr FROM x_portname");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Name"));
      THItem(x("Protocol"));
      THItem(x("Port"));
      THItem(x("Description"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[1]);
	TItem(num2proto($row[2]));
	TItem($row[3]);
	TItem(str_strip($row[4]));
	TItem(ShowLink(x("Edit"),"ports.php?command=edit&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No port found ... Please, click on the 'Add' link in the left 'Port name' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'ports.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'ports.php?command=add');
  MenuSub(x("Port name"),$mysubmenu);
}


?>