<?php

/*
key=module_id
name - name of module
nas - array()... subtypes
desc - description

severity_max - maximal value in following array (0=unlimited)
severity_i - 5el. array
severity_e - 5el. array

format - param format output
check - param check function

p0name - parameter name
p0def - parameter default value
...
p9name
p9def
*/




/* M O D U L E   # 1 */
function mod1formatpp($str) {
  $f=explode("/",$str);
  $proto=num2proto($f[0]);
  $port=num2port($f[1],$f[0]);
  return ShowLink("$proto/$port",PRG_PATH."src/help/ports.php?proto=".$f[0]."&port=".$f[1],'','target="info"')." ($f[2]x)";
}

function mod1format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Unique destinations:"),$fields['p0']);  
    if (isset($fields['p1']))
      $ret[]=array(x("Unique ports used:"),$fields['p1']);
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Target protocol/port (count):"),mod1formatpp($fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Target protocol/port (count):"),mod1formatpp($fields['p3']));
    if (isset($fields['p4']) && $fields['p4'])
      $ret[]=array(x("Target protocol/port (count):"),mod1formatpp($fields['p4']));
    if (isset($fields['p5']) && $fields['p5'])
      $ret[]=array(x("Target protocol/port (count):"),mod1formatpp($fields['p5']));
    if (isset($fields['p6']) && $fields['p6'])
      $ret[]=array(x("Target protocol/port (count):"),mod1formatpp($fields['p6']));
  }
  return $ret;
}

function mod1check() {
  global $p0,$p1,$p2,$error;
  if (!$error && (!is_numeric($p0) || ($p0<20) || ($p0>500)))
    $error=x("Minimal destinations can be in the range [20-500]");
  if (!$error && (!is_numeric($p1) || ($p1<0) || ($p1>99)))
    $error=x("Sensitivity can be in the range [0.0-99.0]");
  if (!$error && (!is_numeric($p2) || ($p2!='0' && $p2!='1')))
    $error=x("Include low source ports can be 0=disable or 1=enable.");
}

$na_mod[1]=array(
'name'=>x("network port scan"),
'nas'=>array(
     1=>x("worm WINS"),
     2=>x("worm NETBIOS"),
     3=>x("worm MS-DS"),
     4=>x("worm SOCKS"),
     5=>x("worm MS-SQL"),
     6=>x("network FS"),
     7=>x("worm web cache"),
     8=>x("worm MY-SQL"),
     9=>x("worm MS terminal"),
    10=>x("worm SWIFT remote"),
    11=>x("worm remote admin"),
    12=>x("worm DABBER"),
    13=>x("worm VNC exploit"),
    14=>x("worm QWIN"),
    15=>x("worm BOTNET scanning"),
    16=>x("ARCServe backup"),
    17=>x("worm MS-EPMAP"),
    18=>x("worm MS-RPC"),
    19=>x("remote file access"),
    20=>x("CheckPoint access"),
    21=>x("worm MS-SQL monitor")
),
'severity_max'=>0,
'severity_i'=>array(-1,1440,120,30,0),
'severity_e'=>array(-1,-1,-1,1440,0),
'p0name'=>x("Minimal observed destinations in 1 minute [20-500]:"),
'p0def'=>'25',
'p1name'=>x("Sensitivity [0-99]:"),
'p1def'=>'50',
'p2name'=>x("Include low source ports [0/1]:"),
'p2def'=>'0',
'desc'=>
"Identify stations infected by worm. In most cases the source of infection are ".
"Windows stations with unpatched IIS server, MS-SQL server or remote ".
"admin software.",
'format'=>'mod1format',
'check'=>'mod1check'
);




/* M O D U L E   # 2 */
function mod2formatpp($str) {
  $f=explode("/",$str);
  $proto=num2proto($f[0]);
  $port=num2port($f[1],$f[0]);
  return ShowLink("$proto/$port",PRG_PATH."src/help/ports.php?proto=".$f[0]."&port=".$f[1],'','target="info"')." ($f[2])";
}

function mod2format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Unique ports used:"),$fields['p0']);
    if (isset($fields['p1']) && $fields['p1'])
      $ret[]=array(x("Target protocol/port (packets):"),mod2formatpp($fields['p1']));
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Target protocol/port (packets):"),mod2formatpp($fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Target protocol/port (packets):"),mod2formatpp($fields['p3']));
    if (isset($fields['p4']) && $fields['p4'])
      $ret[]=array(x("Target protocol/port (packets):"),mod2formatpp($fields['p4']));
    if (isset($fields['p5']) && $fields['p5'])
      $ret[]=array(x("Target protocol/port (packets):"),mod2formatpp($fields['p5']));
  }
  return $ret;
}

function mod2check() {
  global $p0,$p1,$error;
  if (!$error && (!is_numeric($p0) || ($p0<5) || ($p0>1000)))
    $error=x("Minimal low ports can be in the range [5-1000]");
  if (!$error && (!is_numeric($p1) || ($p1!='0' && $p1!='1')))
    $error=x("Include low source ports can be 0=disable or 1=enable.");
}

$na_mod[2]=array(
'name'=>x("host port scan"),
'nas'=>'',
'severity_max'=>0,
'severity_i'=>array(-1,720,60,0,0),
'severity_e'=>array(-1,-1,-1,60,0),
'p0name'=>x("Minimal observed low ports in 1 minute [5-1000]:"),
'p0def'=>'10',
'p1name'=>x("Include low source ports [0/1]:"),
'p1def'=>'0',
'desc'=>
"Identify attackers that scan TCP or UDP service ports for vulnerabilities. ".
"In most cases the source of the attack is an infected server or station.",
'format'=>'mod2format',
'check'=>'mod2check'
);




/* M O D U L E   # 11 */

function mod11format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Total unique destinations:"),$fields['p0']);  
    if (isset($fields['p1']) && $fields['p1'])
      $ret[]=array(x("Total ICMP bytes:"),number2human($fields['p1']));
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Total ICMP packets:"),number2human($fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Used ICMP message:"),num2port($fields['p3'],1));
    if (isset($fields['p0']) && $fields['p0']>1) {
      if (isset($fields['p6']) && $fields['p6'])
        $ret[]=array(x("Most active destination"),xformat_ip(0,$fields['p6']));
      if (isset($fields['p4']) && $fields['p4'])
        $ret[]=array(x("Most active destination - ICMP bytes:"),number2human($fields['p4']));
      if (isset($fields['p5']) && $fields['p5'])
        $ret[]=array(x("Most active destination - ICMP packets:"),number2human($fields['p5']));
    }
  }
  return $ret;
}

function mod11check() {
  global $p0,$p1,$p2,$p3,$p4,$error;
  if (!$error && (!is_numeric($p0) || ($p0<10) || ($p0>10000)))
    $error=x("Minimal packets can be in the range [10-10000]");
  if (!$error && (!is_numeric($p1) || ($p1<1) || ($p1>10000)))
    $error=x("Minimal long packets can be in the range [10-10000]");
  if (!$error && (!is_numeric($p2) || ($p2!="0" && $p2!="1")))
    $error=x("Report unreachable ICMP messages can be 0=disable or 1=enable.");
  if (!$error && (!is_numeric($p3) || ($p3!="0" && $p3!="1")))
    $error=x("Report unusual ICMP messages can be 0=disable or 1=enable.");
  if (!$error && (!is_numeric($p4) || ($p4!="0" && $p4!="1")))
    $error=x("Report ping responces can be 0=disable or 1=enable.");
}

$na_mod[11]=array(
'name'=>x("ICMP flooding"),
'nas'=>array(
     1=>x("Short packet flooding"),
     2=>x("Long packet"),
     3=>x("Long packet flooding")
),
'severity_max'=>0,
'severity_i'=>array(-1,720,120,5,0),
'severity_e'=>array(-1,-1,-1,120,0),
'p0name'=>x("Minimal packets in 1 minute [10-10000]:"),
'p0def'=>'500',
'p1name'=>x("Minimal long packets in 1 minute [10-10000]:"),
'p1def'=>'100',
'p2name'=>x("Report unreachble ICMP messages [0/1]:"),
'p2def'=>'1',
'p3name'=>x("Report unusual ICMP messages [0/1]:"),
'p3def'=>'0',
'p4name'=>x("Report ping responces [0/1]:"),
'p4def'=>'0',
'desc'=>
"Identify ICMP protocol attacks and flooding.",
'format'=>'mod11format',
'check'=>'mod11check'
);




/* M O D U L E   # 12 */

function mod12formatpp($str) {
  $f=explode("/",$str);
  $proto=num2proto($f[0]);
  $port=num2port($f[1],$f[0]);
  return ShowLink("$proto/$port",PRG_PATH."src/help/ports.php?proto=".$f[0]."&port=".$f[1],'','target="info"')." ($f[2])";
}

function mod12format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Total unique sources:"),$fields['p0']);  
    if (isset($fields['p1']) && $fields['p1'])
      $ret[]=array(x("Total TCP/SYN packets:"),number2human($fields['p1']));
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Most active source"),xformat_ip(0,$fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Most active source - TCP/SYN packets"),number2human($fields['p3']));
    if (isset($fields['p4']) && $fields['p4'])
      $ret[]=array(x("Target protocol/port (packets):"),mod12formatpp($fields['p4']));
    if (isset($fields['p5']) && $fields['p5'])
      $ret[]=array(x("Target protocol/port (packets):"),mod12formatpp($fields['p5']));
    if (isset($fields['p6']) && $fields['p6'])
      $ret[]=array(x("Target protocol/port (packets):"),mod12formatpp($fields['p6']));
    if (isset($fields['p7']) && $fields['p7'])
      $ret[]=array(x("Target protocol/port (packets):"),mod12formatpp($fields['p7']));
    if (isset($fields['p8']) && $fields['p8'])
      $ret[]=array(x("Target protocol/port (packets):"),mod12formatpp($fields['p8']));
  }
  return $ret;
}

function mod12check() {
  global $p0,$error;
  if (!$error && (!is_numeric($p0) || ($p0<5) || ($p0>1000)))
    $error=x("Minimal TCP/SYN packets can be in the range [5-1000]");
}

$na_mod[12]=array(
'name'=>x("TCP/SYN flooding"),
'nas'=>'',
'severity_max'=>0,
'severity_i'=>array(-1,720,120,5,0),
'severity_e'=>array(-1,-1,120,30,0),
'p0name'=>x("Minimal packets in 1 minute [10-10000]:"),
'p0def'=>'150',
'desc'=>
"Identify direct or distributed TCP/SYN attacks and flooding.",
'format'=>'mod12format',
'check'=>'mod12check'
);




/* M O D U L E   # 13 */

function mod13formatp_ip($str) {
  $ip=num2ip($str);
  $ip_name=xformat_ip(0,$ip);
  return ShowLink($ip_name,PRG_PATH."src/data/info_ip.php?host=".$ip,'','target="info"');
}

function mod13formatp_data($str) {
  $f=explode("/",$str);
  $bytes=number2human($f[0]);
  $pck=number2human($f[1]);
  $pck_len=floor($f[0]/$f[1]);
  return "$bytes / $pck / $pck_len";
}

function mod13format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Total unique sources/destinations:"),$fields['p0']);  
    if (isset($fields['p1']) && $fields['p1'])
      $ret[]=array(x("Total flooding packets:"),number2human($fields['p1']));
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Total bytes:"),number2human($fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Total packets:"),number2human($fields['p3']));
    if (isset($fields['p2']) && $fields['p2'] && isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Average packet length:"),floor($fields['p2']/$fields['p3']));

    if (isset($fields['p4']) && $fields['p4'] && isset($fields['p5']) && $fields['p5'])
      $ret[]=array(x("Counterpart IP:").'<br/>'.x("Bytes / Packets / Avg packet length"),mod13formatp_ip($fields['p4']).'<br/>'.mod13formatp_data($fields['p5']));
    if (isset($fields['p6']) && $fields['p6'] && isset($fields['p7']) && $fields['p7'])
      $ret[]=array(x("Counterpart IP:").'<br/>'.x("Bytes / Packets / Avg packet length"),mod13formatp_ip($fields['p6']).'<br/>'.mod13formatp_data($fields['p7']));
    if (isset($fields['p8']) && $fields['p8'] && isset($fields['p9']) && $fields['p9'])
      $ret[]=array(x("Counterpart IP:").'<br/>'.x("Bytes / Packets / Avg packet length"),mod13formatp_ip($fields['p8']).'<br/>'.mod13formatp_data($fields['p9']));
  }
  return $ret;
}

function mod13check() {
  global $p0,$p1,$p2,$error;
  if (!$error && (!is_numeric($p0) || ($p0<100) || ($p0>1000000)))
    $error=x("Minimal packets per second for single host can be in the range [100-1000000]");
  if (!$error && (!is_numeric($p1) || ($p1<100) || ($p1>500000)))
    $error=x("Minimal packets per second for distribution can be in the range [100-500000]");
  if (!$error && (!is_numeric($p2) || ($p2<2) || ($p2>50)))
    $error=x("Distribution nodes can be in the range [2-50]");
}

$na_mod[13]=array(
'name'=>x("UDP flooding"),
'nas'=>'',
'severity_max'=>0,
'severity_i'=>array(-1,720,120,5,0),
'severity_e'=>array(-1,-1,120,30,0),
'p0name'=>x("Minimal packets in 1 minute for single host [1000-1000000]:"),
'p0def'=>'40000',
'p1name'=>x("Minimal packets in 1 minute for distributed flooding [500-500000]:"),
'p1def'=>'5000',
'p2name'=>x("Distribution nodes [2-50]:"),
'p2def'=>'4',
'desc'=>
"Identify direct or distributed UDP flooding.",
'format'=>'mod13format',
'check'=>'mod13check'
);




/* M O D U L E   # 21 */
function mod21formatpp($str) {
  $f=explode("/",$str);
  $proto=num2proto($f[0]);
  $port=num2port($f[1],$f[0]);
  return ShowLink("$proto/$port",PRG_PATH."src/help/ports.php?proto=".$f[0]."&port=".$f[1],'','target="info"')." ($f[2])";
}

function mod21format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Total packets:"),$fields['p0']);  
    if (isset($fields['p1']) && $fields['p1'])
      $ret[]=array(x("Target protocol/port (packets):"),mod21formatpp($fields['p1']));
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Target protocol/port (packets):"),mod21formatpp($fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
      $ret[]=array(x("Target protocol/port (packets):"),mod21formatpp($fields['p3']));
    if (isset($fields['p4']) && $fields['p4'])
      $ret[]=array(x("Target protocol/port (packets):"),mod21formatpp($fields['p4']));
  }
  return $ret;
}

function mod21check() {
  global $p0,$p1,$error;
  if (!$error && (!is_numeric($p0) || ($p0<1) || ($p0>50000)))
    $error=x("Minimal packets can be in the range [1-50000]");
  if (!$error && (!is_numeric($p1) || ($p1<1) || ($p1>500000)))
    $error=x("Maximal packets can be in the range [1-500000]");
}

$na_mod[21]=array(
'name'=>x("network games"),
'nas'=>array(
     1=>x("Need for Speed"),
     2=>x("Diablo"),
     3=>x("Civilization"),
     4=>x("Worms 3D"),
     5=>x("DirectX games"),
     6=>x("Railroad Tycoon"),
     7=>x("Athena Sword"),
     8=>x("Unreal"),
     9=>x("TeamSpeak"),
     10=>x("Battlefield 1942"),
     11=>x("Misc. network games"),
     12=>x("BattleZone"),
     13=>x("Age of Empires"),
     14=>x("Heratic, Hexen"),
     15=>x("Doom"),
     16=>x("Call Of Duty, Wolfenstein"),
     17=>x("Battlefield 2142"),
     18=>x("MSN Game Zone"),
     19=>x("Alien vs. Predator"),
    101=>x("America's Army"),
    102=>x("Battle.NET"),
    103=>x("Vietcong"),
    104=>x("Half-Life"),
    105=>x("Quake")
),
'severity_max'=>0,
'severity_i'=>array(-1,-1,1440,720,10),
'severity_e'=>array(-1,-1,-1,1440,30),
'p0name'=>x("Minimal packets in 1 minute [1-50000]:"),
'p0def'=>'200',
'p1name'=>x("Maximal packets in 1 minute [1-500000]:"),
'p1def'=>'2000',
'desc'=>
"Identify well-known games as Half-Life, Quake, Battle.Net, Unreal, MS DirectX Games etc.",
'format'=>'mod21format',
'check'=>'mod21check'
);




/* M O D U L E   # 22 */
function mod22formatpp($str) {
  $f=explode("/",$str);
  $proto=num2proto($f[0]);
  $port=num2port($f[1],$f[0]);
  return ShowLink("$proto/$port",PRG_PATH."src/help/ports.php?proto=".$f[0]."&port=".$f[1],'','target="info"')." ($f[2])";
}

function mod22format($fields) {
  $ret=array();
  if (is_array($fields)) {
    if (isset($fields['p0']))
      $ret[]=array(x("Total unique destinations:"),$fields['p0']);  
    if (isset($fields['p1']) && $fields['p1'])
      $ret[]=array(x("Total packets:"),number2human($fields['p1']));
    if (isset($fields['p2']) && $fields['p2'])
      $ret[]=array(x("Most active destination"),xformat_ip(0,$fields['p2']));
    if (isset($fields['p3']) && $fields['p3'])
        $ret[]=array(x("Most active destination - packets:"),number2human($fields['p3']));
    if (isset($fields['p4']) && $fields['p4'])
      $ret[]=array(x("Target protocol/port (packets):"),mod22formatpp($fields['p4']));
    if (isset($fields['p5']) && $fields['p5'])
      $ret[]=array(x("Target protocol/port (packets):"),mod22formatpp($fields['p5']));
    if (isset($fields['p6']) && $fields['p6'])
      $ret[]=array(x("Target protocol/port (packets):"),mod22formatpp($fields['p6']));
    if (isset($fields['p7']) && $fields['p7'])
      $ret[]=array(x("Target protocol/port (packets):"),mod22formatpp($fields['p7']));
    if (isset($fields['p8']) && $fields['p8'])
      $ret[]=array(x("Target protocol/port (packets):"),mod22formatpp($fields['p8']));
  }
  return $ret;
}

function mod22check() {
  global $p0,$p1,$error;
  if (!$error && (!is_numeric($p0) || ($p0<10) || ($p0>10000)))
    $error=x("Minimal packets can be in the range [10-10000].");
  if (!$error && (!is_numeric($p1) || ($p1<1) || ($p1>1000)))
    $error=x("Minimal observed destinations can be in the range [1-1000].");
}

$na_mod[22]=array(
'name'=>x("p2p applications"),
'nas'=>array(
     1=>x("FastTrack, Kazza"),
     2=>x("Overnet"),
     3=>x("Kademlia"),
     4=>x("Aimster"),
     5=>x("GNUtella"),
     6=>x("GNUtella2"),
     7=>x("WinMX"),
     8=>x("OpenNapster"),
     101=>x("Direct Connect"),
     102=>x("SoulSeek"),
     103=>x("eDonkey"),
     104=>x("BitTorrent")
),
'severity_max'=>0,
'severity_i'=>array(-1,-1,1440,720,10),
'severity_e'=>array(-1,-1,-1,1440,30),
'p0name'=>x("Minimal packets in 1 minute [10-10000]:"),
'p0def'=>'750',
'p1name'=>x("Minimal observed destinations in 1 minute [1-1000]:"),
'p1def'=>'1',
'desc'=>
"Identify well-known peer-2-peer applications as Kazza, eDonkey, BitTorrent, Gnutella, Direct Connect etc.",
'format'=>'mod22format',
'check'=>'mod22check'
);



?>
